#include<iostream>
#include<fstream>
#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<ctime>
#include<math.h> 
#include<string>
#include<cstring>

#define N 100001
#define E 250000
#define read 1
#define write 2

using namespace std;
 

void srand(unsigned seed);

string fileName(int i,int type,string name="",int digit=10)
{
  string No;
  while(i)
    {
      char n='0'+(i%digit);
      No=n+No;
      i/=digit;
    }

  if(type==read)
    return name+No+".txt";
  else
    return name+No+".csv";
}

void QSort(int x[ ],int y[ ], int left, int right);
void Swap(int x[ ],int y[ ], int i, int j);
int r[N]={0};
int q[N]={0};
int B4[100]={0};
int S4[100]={0};
int B1[100]={0};
int S1[100]={0};
int B14[100]={0};
int S14[100]={0};

int main(){
  int i=1,k=1,node_number=1;
  static int a[E]={0};
  static int b[E]={0};
  static int c[N]={0};
  static int d[N]={0};
  static double e[N]={0};
  static int f[N]={0};
  static int ab[N][3000]={0};  //   static int ab[N][N]={0};
  double am=100,bm=20,cm=15,dm=5; //利得表の値　大
  //  double am=30,bm=20,cm=15,dm=10; 
  double B=4; //ノイズの大きさ 

  char s[100];
  char fname[100];
  char name[100];
  int ret, ii=1;

  //  printf("txtfile:");
  // scanf("%s",fname);
  // printf("csvfile::");
  // scanf("%s",name);
  //
  for(int count=1;count<=2;count++){
    ret=0;
    ii=1;
    memset(a,0,sizeof(a));
    memset(b,0,sizeof(b));
    memset(c,0,sizeof(c));
    memset(d,0,sizeof(d));
    memset(f,0,sizeof(f));
    memset(ab,0,sizeof(ab));

    for(int ip=0;ip<N;ip++)
      e[ip]=0.0;

    ifstream fp;
    fp.open(fileName(count,read,"data").c_str());

    int node1,node2;
    while(fp>>a[ii]>>b[ii])
      ii++;

    fp.close();
    
    for(int m=1;m<=N;m++){ //ノードに{+1,-1}を格納
      c[m]=-1;
      f[m]=-1;  }
    
    while(node_number < N){ //a[]の探索
      for(k=1;k<E;k++){ 
	if(node_number==a[k]){  //node_numberに対応する隣接ノードの格納
		      ab[node_number][i]=b[k]; 
		      i++;  }
		  }
		  d[node_number]=i; //a[]で格納したものを続かせるための配列
		  node_number++;
		  i=1;
		} //a[]の探索終了
		
    k=1; node_number=1; 
		
		while(node_number < N) { //b[]の探索
		  for(int k=1;k<E;k++){
		    if(node_number==b[k]){ //node_numberに対応する隣接ノードの格納
		      ab[node_number][d[node_number]]=a[k]; 
		      d[node_number]++;  }     
		  }
		  node_number++;
		} //b[]の探索終了
		
		
		int puls=0;
		for(node_number=1;node_number<N;node_number++){
		  q[node_number]=node_number;  
		  for(int k=1;ab[node_number][k]!=0;k++){
		    puls++;
		  }
		  
		  printf("%d::%d\n",node_number,puls);
		  r[node_number]=puls;
		  puls=0;   
		}
		QSort(r, q, 0, N);
		
		for(int k1=1;k1<N;k1++)
		  printf("%d::%d\n",k1,r[k1]);
		printf("\n");
		for(int k1=1;k1<N*0.16;k1++){
		  c[q[k1]]=1;
		  printf("%d::%d\n",q[k1],c[q[k1]]);}
		printf("\n");
		for(int k1=1;k1<N;k1++)
		  printf("%d::%d\n",k1,c[k1]);
		
		node_number=1; 
		int x,y=0,Tt,total=0,tm;
		double probability,pi,pi2,h,t=0;
		double hi,kk,xj,k2=0;
		h=(am-dm-bm+cm)/(am-dm+bm-cm);
		
		
		for(int z=1;z<=100;z++){ //T+の計算開始　B=4 大
		  srand(z);
		  for(int n=1;;n++){
		    while(node_number < N) { //周りのノードを探索
		      for(k=1;ab[node_number][k]>0;k++){
			x=f[ab[node_number][k]];
			k2++;
			if(x==1){ //利得の計算
			  tm=am-dm;
			  t+=tm;
			}else if(x==-1){
			  tm=bm-cm;
			  t-=tm;
			}
			y+=x; //戦略{+1,-1}を足していく
		      }
		      
		      e[node_number]=y;  y=0;
		      
		      if(t>=0){ //利得の合計が0以上なら1
			c[node_number]=1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj); pi2 = -1*B*(hi + xj);
			probability = 1.0-(exp( pi ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= -1;    
		      } else { //利得の合計が0未満なら-1
			c[node_number]= -1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj);  pi2 = -1*B*(hi + xj);
			probability = 1.0- (exp( pi2 ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
		  	   c[node_number]= 1;  }
		      
	probability = 0.0; k2=0.0;
	
	total+=c[node_number];
	
	if(total==N-1){
	  Tt = n;
	  printf("%d\n",Tt);
	  B4[z]=Tt;
	  break;	}
	
	if(n==20000){
	  printf("%d..20000\n",z);
	  B4[z]=20000;
	  break;   }       
	
	e[node_number]=0;
	node_number++;   
	t=0;    }
		    if(total==N-1) break;
		    if(n==20000) break;
		    total=0; node_number=1;
		    for(int l=1;l<N;l++)
		      f[l]=c[l];  }
		  total = 0;  node_number =1;  t=0;  e[node_number]=0;
		  for(int m=1;m<N;m++){
		    c[m]=-1;
		    f[m]=-1;  }
		  for(int k=1;k<N*0.16;k++){
		    c[q[k]]=1;
		    f[q[k]]=1;  }
		} //B=4,利得大終わり
		
		
		am=30,bm=20,cm=15,dm=10; 
		B=4; //ノイズの大きさ 
		h=(am-dm-bm+cm)/(am-dm+bm-cm);
		total=0;  node_number=1;  t=0;  e[node_number]=0; y=0; k2=0;
		for(int m=1;m<N;m++){
		  c[m]=-1;
		  f[m]=-1;  }
		for(int k=1;k<N*0.16;k++){
		  c[q[k]]=1;
		  f[q[k]]=1;  }
		
		
		for(int z=1;z<=100;z++){ //T+の計算開始 B=4 小
		  srand(z);
		  for(int n=1;;n++){
		    while(node_number < N) { //周りのノードを探索
		      for(k=1;ab[node_number][k]>0;k++){
			x=f[ab[node_number][k]];
			k2++;
			if(x==1){ //利得の計算
			  tm=am-dm;
			  t+=tm;
			}else if(x==-1){
			  tm=bm-cm;
			  t-=tm;
			}
			y+=x; //戦略{+1,-1}を足していく
		      }
		      
		      e[node_number]=y;  y=0;
		      
		      if(t>=0){ //利得の合計が0以上なら1
			c[node_number]=1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj); pi2 = -1*B*(hi + xj);
			probability = 1.0-(exp( pi ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= -1;    
		      } else { //利得の合計が0未満なら-1
			c[node_number]= -1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj);  pi2 = -1*B*(hi + xj);
			probability = 1.0- (exp( pi2 ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= 1;  }

		      probability = 0.0; k2=0.0;
		      
		      total+=c[node_number];
		      
		      if(total==N-1){
			Tt = n;
			printf("%d\n",Tt);
			S4[z]=Tt;
			break;	}
		      
		      if(n==20000){
			printf("%d..20000\n",z);
			S4[z]=20000;
			break;   }       
		      
		      e[node_number]=0;
		      node_number++;   
		      t=0;  
		    }
		    if(total==N-1) break;
		    if(n==20000) break;
		    total=0; node_number=1;
		    for(int l=1;l<N;l++)
		      f[l]=c[l]; 
		  }
		  total = 0;  node_number =1;  t=0;  e[node_number]=0;
		  for(int m=1;m<N;m++){
		    c[m]=-1;
		    f[m]=-1;  }
		  for(int k=1;k<N*0.16;k++){
		    c[q[k]]=1;
		    f[q[k]]=1;  }
		} //B=4,利得小終わり
		
		
		am=100,bm=20,cm=15,dm=5; 
		B=3.37; //ノイズの大きさ 
		h=(am-dm-bm+cm)/(am-dm+bm-cm);
		total = 0;  node_number =1;  t=0;  e[node_number]=0; y=0; k2=0;
		for(int m=1;m<N;m++){
		  c[m]=-1;
		  f[m]=-1;  }
		for(int k=1;k<N*0.16;k++){
		  c[q[k]]=1;
		  f[q[k]]=1;  }
		
		
		for(int z=1;z<=100;z++){ //T+の計算開始 B=3.37 大
		  srand(z);
		  for(int n=1;;n++){
		    while(node_number < N) { //周りのノードを探索
		      for(k=1;ab[node_number][k]>0;k++){
			x=f[ab[node_number][k]];
			k2++;
			if(x==1){ //利得の計算
			  tm=am-dm;
			  t+=tm;
			}else if(x==-1){
			  tm=bm-cm;
			  t-=tm;
			}
			y+=x; //戦略{+1,-1}を足していく
		      }
		      
		      e[node_number]=y;  y=0;
		      
		      if(t>=0){ //利得の合計が0以上なら1
			c[node_number]=1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj); pi2 = -1*B*(hi + xj);
			probability = 1.0-(exp( pi ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= -1;    
		      } else { //利得の合計が0未満なら-1
			c[node_number]= -1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj);  pi2 = -1*B*(hi + xj);
			probability = 1.0- (exp( pi2 ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= 1;  }
		      
		      probability = 0.0; k2=0.0;
		      
		      total+=c[node_number];
		      
		      if(total==N-1){
			Tt = n;
			printf("%d\n",Tt);
			B1[z]=Tt;
			break;	}
		      
		      if(n==20000){
			printf("%d..20000\n",z);
			B1[z]=20000;
			break;   }       
		      
		      e[node_number]=0;
		      node_number++;   
		      t=0;    }
		    if(total==N-1) break;
		    if(n==20000) break;
		    total = 0;
		    node_number=1;
		    for(int l=1;l<N;l++)
		      f[l]=c[l];  }
		  total = 0;  node_number =1;  t=0;  e[node_number]=0;
		  for(int m=1;m<N;m++){
		    c[m]=-1;
		    f[m]=-1;  }
		  for(int k=1;k<N*0.16;k++){
		    c[q[k]]=1;
		    f[q[k]]=1;  }
		} //B=3.37,利得大終わり
		
		
		am=30,bm=20,cm=15,dm=10; 
		B=3.37; //ノイズの大きさ 
		h=(am-dm-bm+cm)/(am-dm+bm-cm);
		total = 0;  node_number =1;  t=0;  e[node_number]=0; y=0; k2=0;
		for(int m=1;m<N;m++){
		  c[m]=-1;
		  f[m]=-1;  }
		for(int k=1;k<N*0.16;k++){
		  c[q[k]]=1;
		  f[q[k]]=1;  }
		

		
		for(int z=1;z<=100;z++){ //T+の計算開始 B=3.37 利得小
        srand(z);
	for(int n=1;;n++){
	  while(node_number < N) { //周りのノードを探索
	    for(k=1;ab[node_number][k]>0;k++){
	      x=f[ab[node_number][k]];
	      k2++;
	      if(x==1){ //利得の計算
		tm=am-dm;
		t+=tm;
	      }else if(x==-1){
		tm=bm-cm;
		t-=tm;
	      }
	      y+=x; //戦略{+1,-1}を足していく
	    }
	    
	    e[node_number]=y;  y=0;
	    
	    if(t>=0){ //利得の合計が0以上なら1
	      c[node_number]=1;
	      hi=k2*h;  xj=e[node_number];
	      pi = B*(hi + xj); pi2 = -1*B*(hi + xj);
	      probability = 1.0-(exp( pi ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
	      if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
		c[node_number]= -1;    
	    } else { //利得の合計が0未満なら-1
	      c[node_number]= -1;
	      hi=k2*h;  xj=e[node_number];
	      pi = B*(hi + xj);  pi2 = -1*B*(hi + xj);
	      probability = 1.0- (exp( pi2 ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
	      if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
		c[node_number]= 1;  }
	    
	    probability = 0.0; k2=0.0;
	    
	    total+=c[node_number];
	    
	    if(total==N-1){
	      Tt = n;
	      printf("%d\n",Tt);
	      S1[z]=Tt;
	      break;	}
	    
	    if(n==20000){
	      printf("%d..20000\n",z);
	      S1[z]=20000;
	      break;   }       
	    
	    e[node_number]=0;
	    node_number++;   
	    t=0;    }
	  if(total==N-1) break;
	  if(n==20000) break;
	  total = 0;
	  node_number=1;
	  for(int l=1;l<N;l++)
	    f[l]=c[l];  }
	total = 0;  node_number =1;  t=0;  e[node_number]=0;
	for(int m=1;m<N;m++){
	  c[m]=-1;
	  f[m]=-1;  }
	for(int k=1;k<N*0.16;k++){
	  c[q[k]]=1;
	  f[q[k]]=1;  }
		} //B=3.37,利得小終わり
		
		am=100,bm=20,cm=15,dm=5; 
		B=2.84; //ノイズの大きさ 
		h=(am-dm-bm+cm)/(am-dm+bm-cm);
		total = 0;  node_number =1;  t=0;  e[node_number]=0; y=0; k2=0;
		for(int m=1;m<N;m++){
		  c[m]=-1;
		  f[m]=-1;  }
		for(int k=1;k<N*0.16;k++){
		  c[q[k]]=1;
		  f[q[k]]=1;  }
		
		
		for(int z=1;z<=100;z++){ //T+の計算開始 B=2.84 利得大
		  srand(z);
		  for(int n=1;;n++){
		    while(node_number < N) { //周りのノードを探索
		      for(k=1;ab[node_number][k]>0;k++){
			x=f[ab[node_number][k]];
			k2++;
			if(x==1){ //利得の計算
			  tm=am-dm;
			  t+=tm;
			}else if(x==-1){
			  tm=bm-cm;
			  t-=tm;
			}
			y+=x; //戦略{+1,-1}を足していく
		      }
		      
		      e[node_number]=y;  y=0;
		      
		      if(t>=0){ //利得の合計が0以上なら1
			c[node_number]=1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj); pi2 = -1*B*(hi + xj);
			probability = 1.0-(exp( pi ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= -1;    
		      } else { //利得の合計が0未満なら-1
			c[node_number]= -1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj);  pi2 = -1*B*(hi + xj);
			probability = 1.0- (exp( pi2 ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= 1;  }
		      
		      probability = 0.0; k2=0.0;
		      
		      total+=c[node_number];
		      
		      if(total==N-1){
			Tt = n;
			printf("%d\n",Tt);
			B14[z]=Tt;
			break;	}
		      
		      if(n==20000){
			printf("%d..20000\n",z);
			B14[z]=20000;
			break;   }       
		      
		      e[node_number]=0;
		      node_number++;   
		      t=0;    }
		    if(total==N-1) break;
		    if(n==20000) break;
		    total = 0;
		    node_number=1;
		    for(int l=1;l<N;l++)
		      f[l]=c[l];  }
		  total = 0;  node_number =1;  t=0;  e[node_number]=0;
		  for(int m=1;m<N;m++){
		    c[m]=-1;
		    f[m]=-1;  }
		  for(int k=1;k<N*0.16;k++){
		    c[q[k]]=1;
		    f[q[k]]=1;  }
		} //B=2.84,利得大終わり
		
		am=30,bm=20,cm=15,dm=10; 
		B=2.84; //ノイズの大きさ 
		h=(am-dm-bm+cm)/(am-dm+bm-cm);
		total = 0;  node_number =1;  t=0;  e[node_number]=0; y=0; k2=0;
		for(int m=1;m<N;m++){
		  c[m]=-1;
		  f[m]=-1;  }
		for(int k=1;k<N*0.16;k++){
		  c[q[k]]=1;
		  f[q[k]]=1;  }
		
		
		for(int z=1;z<=100;z++){ //T+の計算開始 B=2.84 利得小
		  srand(z);
		  for(int n=1;;n++){
		    while(node_number < N) { //周りのノードを探索
		      for(k=1;ab[node_number][k]>0;k++){
			x=f[ab[node_number][k]];
			k2++;
			if(x==1){ //利得の計算
			  tm=am-dm;
			  t+=tm;
			}else if(x==-1){
			  tm=bm-cm;
			  t-=tm;
			}
			y+=x; //戦略{+1,-1}を足していく
		      }
		      
		      e[node_number]=y;  y=0;
		      
		      if(t>=0){ //利得の合計が0以上なら1
			c[node_number]=1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj); pi2 = -1*B*(hi + xj);
			probability = 1.0-(exp( pi ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= -1;    
		      } else { //利得の合計が0未満なら-1
			c[node_number]= -1;
			hi=k2*h;  xj=e[node_number];
			pi = B*(hi + xj);  pi2 = -1*B*(hi + xj);
			probability = 1.0- (exp( pi2 ) / ( exp( pi ) + exp( pi2 ) )); //確率の計算
			if( (double)rand()/RAND_MAX < probability ) //ノイズ発生
			  c[node_number]= 1;  }
		      
		      probability = 0.0; k2=0.0;
		      
		      total+=c[node_number];
		      
		      if(total==N-1){
			Tt = n;
			printf("%d\n",Tt);
			S14[z]=Tt;
			break;	}
		      
		      if(n==20000){
			printf("%d..20000\n",z);
			S14[z]=20000;
			break;   }       
		      
		      e[node_number]=0;
		      node_number++;   
		      t=0;    }
		    if(total==N-1) break;
		    if(n==20000) break;
		    total = 0;
		    node_number=1;
		    for(int l=1;l<N;l++)
		      f[l]=c[l];  }
		  total = 0;  node_number =1;  t=0;  e[node_number]=0;
		  for(int m=1;m<N;m++){
		    c[m]=-1;
		    f[m]=-1;  }
		  for(int k=1;k<N*0.16;k++){
		    c[q[k]]=1;
		    f[q[k]]=1;  }
		} //B=2.84,利得小終わり
		
		ofstream f;
		f.open(fileName(count,write,"2data").c_str());
		if(f==NULL){
		  printf("No such %sfile\n",name);
		  return -1;
		}
		for(int z=1;z<=100;z++)
		  f<<s<<" "<<B4[z]<<" "<<S4[z]<<" "<<B1[z]<<" "<<S1[z]<<" "<<B14[z]<<" "<<S14[z]<<endl;;
		
		f.close();
		printf("wrote file\n");
  }
  return 0;
}

/* クイックソートを行う */
void QSort(int x[ ],int y[ ], int left, int right)
{
    int i, j;
    int pivot;

    i = left;                      /* ソートする配列の一番小さい要素の添字 */
    j = right;                     /* ソートする配列の一番大きい要素の添字 */

    pivot = x[(left + right) / 2]; /* 基準値を配列の中央付近にとる */

    while (1) {                    /* 無限ループ */

        while (x[i] > pivot)       /* pivot より大きい値が */
            i++;                   /* 出るまで i を増加させる */

        while (pivot > x[j])       /* pivot より小さい値が */
            j--;                   /*  出るまで j を減少させる */
        if (i >= j)                /* i >= j なら */
            break;                 /* 無限ループから抜ける */

        Swap(x, y, i, j);             /* x[i] と x[j]を交換 */
        i++;                       /* 次のデータ */
        j--;
    }     

    if (left < i - 1)              /* 基準値の左に 2 以上要素があれば */
      QSort(x,y,  left, i - 1);     /* 左の配列を Q ソートする */
    if (j + 1 <  right)            /* 基準値の右に 2 以上要素があれば */
      QSort(x,y,  j + 1, right);    /* 右の配列を Q ソートする */
}

  /* 配列の要素を交換する */
void Swap(int x[ ],int y[ ], int i, int j)
{
  int temp,roll;

    temp = x[i];
    x[i] = x[j];
    x[j] = temp;

    roll=y[i];
    y[i]=y[j];
    y[j]=roll;
}
